-- 00
    math.randomseed( os.time() )
    dt = love.timer.getDelta()


-- Load images
    img = {}
    img.map = {}
    img.map.terrain = {
        [1] = love.graphics.newImage("sprites/map/ground1.png"),
        [2] = love.graphics.newImage("sprites/map/ground2.png"),
        [3] = love.graphics.newImage("sprites/map/ground3.png"),
        [4] = love.graphics.newImage("sprites/map/ground4.png"),
        [5] = love.graphics.newImage("sprites/map/ground5.png"),
        [6] = love.graphics.newImage("sprites/map/ground6.png"),
        [7] = love.graphics.newImage("sprites/map/ground7.png"),
        [8] = love.graphics.newImage("sprites/map/ground8.png"),
        [9] = love.graphics.newImage("sprites/map/ground9.png"),
    }
    img.map.selection = {
        [1] = love.graphics.newImage("sprites/map/selection.png"),
    }
    img.map.entity = {
        [1] = love.graphics.newImage("sprites/map/hq.png"),
    }
    img.ui = {}
    img.ui.box = {
        [1] = love.graphics.newImage("sprites/ui/box1.png"),
    }
    img.ui.checkboxPassive = {
        [1] = love.graphics.newImage("sprites/ui/checkBox_passive.png"),
    }
    img.ui.checkBoxHighlight = {
        [1] = love.graphics.newImage("sprites/ui/checkBox_highlight.png"),
    }
    img.ui.checkboxActive = {
        [1] = love.graphics.newImage("sprites/ui/checkBox_active.png"),
    }
    img.button ={}
    img.button.passive = {
        [1] = love.graphics.newImage("sprites/ui/button_passive.png"),
    }
    img.button.active = {
        [1] = love.graphics.newImage("sprites/ui/button_active.png"),
    }
-- Fonts
    font = {
        [1] = {}
    }
-- Cursors
    cursor = {
        [1] = love.mouse.newCursor("sprites/ui/pointerA.png", 0,0),
        [2] = love.mouse.newCursor("sprites/ui/pointerCrosshair.png", 32/2, 32/2),
    }
    love.mouse.setCursor(cursor[1])
-- Game Mechanics
    gm ={}
    gm.screen = {}
    gm.screen.i = 0
    gm.screen.map = 1 --(2) I only do this for the map, in case I have to change the screen id for the map later on. I'll reference always to this number
    -->>
        --[[
            Screen  1: Title Screen
            Screen  2: Map Screen
        ]]
    gm.tileWidth = img.map.terrain[1]:getWidth()
    mouse = {}
        mouse.clickL = false
        mouse.wheel = {}
        mouse.wheel.scroll = 0
    camera = {} -- id corresponds to the screen.i
        camera[1] = {} -- normal camera 
            camera[1].x = 0
            camera[1].y = 0
            camera[1].speed = 0
        camera[2] = {} -- camera for map
            camera[2].x = love.graphics.getWidth() / 2 - (0 * gm.tileWidth)
            camera[2].y = (love.graphics.getHeight() / 2) - (1 * gm.tileWidth)
            camera[2].speed = 5

    function coordPosConverter(mode,v) -- pos is in pixels, coord is in tiles
        local equalsV = 0
        if mode == "posToCoord" then
            equalsV = math.floor(v / gm.tileWidth)
        elseif mode == "CoordToPos" then
            equalsV = v * gm.tileWidth
        end
        return equalsV
    end
-- Map
    map = {}
    map.width = coordPosConverter("posToCoord",love.graphics.getWidth()) + 5
    if map.width%2 == 0 then
        map.width = map.width + 1
    end
    --map.width = 3 -- in tiles, min 3 (debug)
    map.height = coordPosConverter("posToCoord",love.graphics.getHeight()) + 2
    if map.height%2 == 0 then
        map.height = map.height + 1
    end
    --map.height = 3 -- in tiles, min 3 (debug)
    map.i = 1 -- map in use
    map[1] = {}
    map[1].canvasPosX = -math.floor(coordPosConverter("CoordToPos",(map.width-1)/2)) -- all this is to compensate the camera[2]
    map[1].canvasPosY = -math.floor(coordPosConverter("CoordToPos",(map.height-1)/2))
    map[1].canvas = love.graphics.newCanvas(
            coordPosConverter("CoordToPos",map.width),
            coordPosConverter("CoordToPos",map.height))
    map[1].id = 1
    map[1].tile = {}
    map[1].tile.n = 0
    function createTile(mapId,coordX,coordY)
        map[mapId].tile.n = map[mapId].tile.n + 1
        local n = map[mapId].tile.n
        map[mapId].tile[n] = {}
        map[mapId].tile[n].id = n
        map[mapId].tile[n].coordX = coordX
        map[mapId].tile[n].coordY = coordY
        map[mapId].tile[n].posX = coordPosConverter("CoordToPos",coordX)
        map[mapId].tile[n].posY = coordPosConverter("CoordToPos",coordY)
        --[[ for debug
            if coordX == 16 and coordY == 13 then
                map[mapId].tile[n].img = img.map.entity[1] --for debug
            else
                map[mapId].tile[n].img = img.map.terrain[math.random(1,#img.map.terrain)]
                --map[mapId].tile[n].img = img.map.entity[1] --for debug
            end
        ]]
        map[mapId].tile[n].img = img.map.terrain[math.random(1,#img.map.terrain)]
        --map[mapId].tile[n].img = img.map.entity[1] --for debug
        love.graphics.draw(map[mapId].tile[n].img,map[mapId].tile[n].posX,map[mapId].tile[n].posY,0,1,1)
    end
    function updateTiles()
    end
-- Handlers
    function handlerExitGame()
        love.event.quit()
    end
    function handlerEmpty()
    end
    function handlerScreenTitle()
        gm.screen.i = 1
    end
    function handlerScreenMap()
        gm.screen.i = 2
    end
    function handlerEntityLeftClick()
    end
    function handlerEntityRightClick()
        --menu[2].isDrawn = true
    end
-- Buttons
    button = {}
    button.activeId = {}
    button.textNormalColor = {1,1,1}
    button.textHiglightColor = {1, 0.8, 0}
    button.fontSize = {
        [1] = 30
    }
    button.font = {
        [1] = love.graphics.newFont("fonts/kenvector_future_thin.ttf", button.fontSize[1]) 
    }
    button[1] = {text = "New Game"}
        button[1].screen = 1
        button[1].imgPassive = img.button.passive[1]
        button[1].imgActive = img.button.active[1]
        button[1].buttonPosX = (love.graphics.getWidth() - button[1].imgPassive:getWidth()) * 0.5
        button[1].buttonPosY = 200
        button[1].font = button.font[1]
        button[1].textNormalColor = button.textNormalColor
        button[1].textHighlightColor = button.textHiglightColor
        button[1].handler = handlerScreenMap
    button[2] = {text = "Settings"}
        button[2].screen = 2
        button[2].imgPassive = img.button.passive[1]
        button[2].imgActive = img.button.active[1]
        button[2].buttonPosX = (love.graphics.getWidth() - button[2].imgPassive:getWidth()) * 0.5
        button[2].buttonPosY = 260
        button[2].font = button.font[1]
        button[2].textNormalColor = button.textNormalColor
        button[2].textHighlightColor = button.textHiglightColor
        button[2].handler = handlerEmpty
    button[3] = {text = "Exit Game"}
        button[3].screen = 1
        button[3].imgPassive = img.button.passive[1]
        button[3].imgActive = img.button.active[1]
        button[3].buttonPosX = (love.graphics.getWidth() - button[2].imgPassive:getWidth()) * 0.5
        button[3].buttonPosY = 320
        button[3].font = button.font[1]
        button[3].textNormalColor = button.textNormalColor
        button[3].textHighlightColor = button.textHiglightColor
        button[3].handler = handlerExitGame
    --
    function calculateBottonValues()
        for i = 1, #button do
            button[i].imgUsed = button[i].imgPassive
            button[i].textWidth = button[i].font:getWidth(button[i].text)
            button[i].textHeight = button[i].font:getHeight(button[i].text)
            button[i].textPosX = button[i].buttonPosX + (button[i].imgUsed:getWidth() - button[i].textWidth) * 0.5
            button[i].textPosYPassive = button[i].buttonPosY + (button[i].imgUsed:getHeight() - button[i].textHeight) * 0.3
            button[i].textPosYActive = button[i].buttonPosY + (button[i].imgUsed:getHeight() - button[i].textHeight) * 0.7
            button[i].textPosY = button[i].textPosYPassive
            button[i].isHighlight = false
        end
    end
    calculateBottonValues()
    function updateButtons()
        local n = 0
        for i = 1, #button do
            if button[i].screen == gm.screen.i then
                n = n + 1
                button.activeId[n] = i
            end
        end
    end
    function drawButton()
        local mouseX = love.mouse.getX()
        local mouseY = love.mouse.getY()
        for i,v in ipairs(button.activeId) do
            if  mouseX >= button[v].buttonPosX + camera[gm.screen.i].x and
                mouseX <= button[v].buttonPosX + camera[gm.screen.i].x + button[v].imgUsed:getWidth() and
                mouseY >= button[v].buttonPosY + camera[gm.screen.i].y and
                mouseY <= button[v].buttonPosY + camera[gm.screen.i].y + button[v].imgUsed:getHeight()
            then
                button[v].isHighlight = true
            else
                button[v].isHighlight = false
            end
            if  love.mouse.isDown(1) == true and
                button[v].isHighlight == true            
            then
                button[v].imgUsed = button[v].imgActive
                button[v].textPosY = button[v].textPosYActive
            else
                button[v].imgUsed = button[v].imgPassive
                button[v].textPosY = button[v].textPosYPassive
            end
            love.graphics.setColor(1,1,1)
            love.graphics.draw(button[v].imgUsed, button[v].buttonPosX, button[v].buttonPosY)
            if  button[v].isHighlight == true then
                love.graphics.setColor(button[v].textHighlightColor[1],button[v].textHighlightColor[2],button[v].textHighlightColor[3])
            else
                love.graphics.setColor(button[v].textNormalColor[1],button[v].textNormalColor[2],button[v].textNormalColor[3])
            end
            love.graphics.setFont(button[v].font)
            love.graphics.print(button[v].text, button[v].textPosX, button[v].textPosY)
        end
    end
-- Menus
    local menu = {
        [1] = {}, -- Main Menu
        [2] = {}, -- test scroll
        [3] = {}, -- 2nd test scroll 
        [4] = {} -- test scroll with selection circle
    }
    menu.object = {}
    menu.object.n = 0


-- Objects                          (anything that can be clicked with the mouse) All entities are objects, but not all objects are entities.
    local object = {}
        object.n = 0
    function createObject(table)
            object.n = object.n + 1
            local n = object.n
            object[n] = {}
            -- Variables
            object[n].id = n
            object[n].originId = table.id
            object[n].screen = table.screen
            object[n].isCheckBox = table.isCheckBox
            object[n].isOnlyText = table.isOnlyText
            object[n].hasBackground = table.hasBackground
            object[n].handlerL = table.handlerL
            object[n].handlerR = table.handlerR
            object[n].alwaysDrawn = table.alwaysDrawn
            object[n].posX = table.posX
            object[n].posY = table.posY
            object[n].originalPosY = table.posY
            object[n].hasImg = table.hasImg
            object[n].imgPassive = table.imgPassive
            object[n].imgActive = table.imgActive
            object[n].imgUsed = table.imgPassive
            object[n].isEntity = table.isEntity
            object[n].isButton = table.isButton
            object[n].hasText = table.hasText
                object[n].text = table.text
                object[n].textColorNormal = table.textColorNormal
                object[n].textColorHighlight = table.textColorHighlight
                object[n].fontSize = table.fontSize
                object[n].font = table.font
            object[n].hasScroll = table.hasScroll
                object[n].scrollSumSaved = 0
                object[n].scrollDist = table.scrollDist
                object[n].scissorPosX = table.scissorPosX
                object[n].scissorPosY = table.scissorPosY
                object[n].scissorWidth = table.scissorWidth
                object[n].scissorHeight = table.scissorHeight
                object[n].scrollTotalN = table.scrollTotalN
                object[n].scrollVisibleN = table.scrollVisibleN
            -- Constants at creation
            object[n].isDrawn = false
            object[n].isHighlight = false
            object[n].checkBoxChecked = false

        end
    
    function updateObjects()
        local mouseX = love.mouse.getX()
        local mouseY = love.mouse.getY()
        object.drawnObjectIds = {}
        local idN = 0
        local scrollEnabled = false
        local scrollMax = 0

        for i = 1, #object do
            if object[i].screen == gm.screen.i and object[i].isDrawn == true 
                or 
                object[i].screen == gm.screen.i and object[i].alwaysDrawn == true
            then
                idN = idN + 1
                object.drawnObjectIds[idN] = object[i].id
            end
        end
        for i,v in ipairs(object.drawnObjectIds) do
            if object[v].hasScroll == true then
                if mouseX >= object[v].scissorPosX + camera[gm.screen.i].x and
                    mouseX <= object[v].scissorPosX + camera[gm.screen.i].x + object[v].scissorWidth and
                    mouseY >= object[v].scissorPosY + camera[gm.screen.i].y and
                    mouseY <= object[v].scissorPosY + camera[gm.screen.i].y + object[v].scissorHeight
                then
                    scrollEnabled = true
                    object[v].scrollSumSaved = object[v].scrollSumSaved - mouse.wheel.scroll
                    scrollMax = object[v].scrollTotalN - object[v].scrollVisibleN + 1
                    if object[v].scrollSumSaved > 0 and
                        object[v].scrollSumSaved < scrollMax
                    then
                        object[v].posY = object[v].posY + object[v].scrollDist * mouse.wheel.scroll
                    elseif object[v].scrollSumSaved >= scrollMax then
                        object[v].scrollSumSaved = scrollMax
                        object[v].posY = object[v].originalPosY - object[v].scrollDist * (object[v].scrollSumSaved - 1)
                     else
                        object[v].scrollSumSaved = 0
                        object[v].posY = object[v].originalPosY
                    end
                end
            end
        end
    end
    function drawObject()
        local mouseX = love.mouse.getX()
        local mouseY = love.mouse.getY()
        local hooverPosX1, hooverPosX2, hooverPosY1, hooverPosY2 = 0,0,0,0
        local scissorPosX, scissorPosY = 0,0
        for i,v in ipairs(object.drawnObjectIds) do
            -- setting variables
                hooverPosX1 = object[v].posX + camera[gm.screen.i].x
                hooverPosX2 = object[v].posX + camera[gm.screen.i].x + object[v].imgUsed:getWidth()
                hooverPosY1 = object[v].posY + camera[gm.screen.i].y
                hooverPosY2 = object[v].posY + camera[gm.screen.i].y + object[v].imgUsed:getHeight()
                if object[v].hasScroll == true then
                    scissorPosX = object[v].scissorPosX + camera[gm.screen.i].x
                    scissorPosY = object[v].scissorPosY + camera[gm.screen.i].y
                end
            -- hasScroll
                if object[v].hasScroll == true then
                    local showRect = true -- this is for debug
                    if showRect == true then -- this is for debug
                        love.graphics.setColor(0.2,0.2,0.2)
                        love.graphics.rectangle("line",object[v].scissorPosX,object[v].scissorPosY,object[v].scissorWidth,object[v].scissorHeight)    
                    end
                    love.graphics.setScissor(scissorPosX,scissorPosY,object[v].scissorWidth,object[v].scissorHeight)  
                end   

                love.graphics.setColor(1,1,1)
            -- isCheckBox
                if object[v].isCheckBox == true then
                    if mouseX >= hooverPosX1 and
                        mouseX <= hooverPosX2 and
                        mouseY >= hooverPosY1 and
                        mouseY <= hooverPosY2     
                    then
                        object[v].isHighlight = true
                        if mouse.clickL == true then
                            if object[v].checkBoxChecked == true then
                                object[v].checkBoxChecked = false
                            else
                                object[v].checkBoxChecked = true
                            end
                        end
                    else
                        object[v].isHighlight = false
                    end
                    if object[v].checkBoxChecked == true then
                        object[v].imgUsed = img.ui.checkboxActive[1]
                    else
                        if object[v].isHighlight == true then
                            object[v].imgUsed = img.ui.checkBoxHighlight[1]
                        else
                            object[v].imgUsed = img.ui.checkboxPassive[1]
                        end
                    end
                    love.graphics.draw(object[v].imgUsed, object[v].posX, object[v].posY)
            -- isButton
                elseif object[v].isButton == true then
                    if mouseX >= hooverPosX1 and
                        mouseX <= hooverPosX2 and
                        mouseY >= hooverPosY1 and
                        mouseY <= hooverPosY2     
                    then
                        object[v].isHighlight = true
                    else
                        object[v].isHighlight = false
                    end
                    if love.mouse.isDown(1) == true and
                        object[v].isHighlight == true
                    then
                        object[v].imgUsed = object[v].imgActive
                    else
                        object[v].imgUsed = object[v].imgPassive
                    end
                    love.graphics.draw(object[v].imgUsed, object[v].posX, object[v].posY)
                    love.graphics.setFont(object[v].font)
                    if object[v].isHighlight == true then
                        love.graphics.setColor(object[v].textColorHighlight[1],object[v].textColorHighlight[2],object[v].textColorHighlight[3])
                    else
                        love.graphics.setColor(object[v].textColorNormal[1],object[v].textColorNormal[2],object[v].textColorNormal[3])
                    end
                    local textWidth = object[v].font:getWidth(object[v].text)
                    local textHeight = object[v].font:getHeight(object[v].text)
                    local textPosX = object[v].posX + (object[v].imgUsed:getWidth() - textWidth) * 0.5
                    local textPosY = object[v].posY + (object[v].imgUsed:getHeight() - textHeight) * 0.3
                    if love.mouse.isDown(1) == true and
                        object[v].isHighlight == true
                    then
                        textPosY = object[v].posY + (object[v].imgUsed:getHeight() - textHeight) * 0.7
                    end
                    love.graphics.print(object[v].text, textPosX, textPosY)
            -- isOnlyText
                elseif object[v].isOnlyText == true then
                    if mouseX >= scissorPosX and
                        mouseX <= scissorPosX + object[v].scissorWidth and
                        mouseY >= object[v].posY + camera[gm.screen.i].y and
                        mouseY <= object[v].posY + camera[gm.screen.i].y + object[v].font:getHeight(object[v].text)
                    then
                        object[v].isHighlight = true
                    else
                        object[v].isHighlight = false
                    end
                    love.graphics.setFont(object[v].font)
                    if object[v].isHighlight == true then
                        love.graphics.setColor(object[v].textColorHighlight[1],object[v].textColorHighlight[2],object[v].textColorHighlight[3])
                    else
                        love.graphics.setColor(object[v].textColorNormal[1],object[v].textColorNormal[2],object[v].textColorNormal[3])
                    end
                    local textWidth = object[v].font:getWidth(object[v].text)
                    local textHeight = object[v].font:getHeight(object[v].text)
                    local textPosX = object[v].posX 
                    local textPosY = object[v].posY 
                    love.graphics.print(object[v].text, textPosX, textPosY)
            -- isEntity
                elseif object[v].isEntity == true then
                    if mouseX >= hooverPosX1 and
                        mouseX <= hooverPosX2 and
                        mouseY >= hooverPosY1 and
                        mouseY <= hooverPosY2     
                    then
                        object[v].isHighlight = true
                        love.graphics.draw(img.map.selection[1], object[v].posX, object[v].posY)
                    else
                        object[v].isHighlight = false
                    end
                    love.graphics.draw(object[v].imgUsed, object[v].posX, object[v].posY)
                end
            love.graphics.setColor(1,1,1)
            love.graphics.setScissor()
        end
    end

-- Navigation inputs
    function love.mousepressed(x, y, button, istouch)
        if button == 1 then
            mouse.clickL = true -- only for button animation purposes
        end 
    end
    function love.mousereleased(x, y, button)
        if button == 4 then
            if gm.screen.i == 2 then
                handlerScreenTitle()
            end
        end
        for i,v in ipairs(button.activeId) do
            if button[v].isHighlight == true then
                if button == 1 then
                    button[v].handler()
                end
            end
        end
        for i,v in ipairs(object.drawnObjectIds) do
            if object[v].isHighlight == true then
                if button == 1 and object[v].handlerL then
                    object[v].handlerL()
                elseif button == 2 and object[v].handlerR then
                    object[v].handlerR()
                end
            end
        end
    end
    function love.wheelmoved(x, y)
        if y > 0 then
            mouse.wheel.scroll = mouse.wheel.scroll + 1
        elseif y < 0 then
            mouse.wheel.scroll = mouse.wheel.scroll - 1
        end
    end
 
-- Entities                         All entities can be objects, but not all objects are entities.
    local entity = {}
        entity.n = 0

    function createEntity(
        name,
        coordX, coordY,
        speed,
        img,
        canBeOnMap
    )
        entity.n = entity.n + 1
        local n = entity.n
        entity[n] = {}
        -- Variables
        entity[n].id = n
        entity[n].screen = 2 -- debug
        entity[n].name = name
        entity[n].coordX = coordX 
        entity[n].coordY = coordY
        entity[n].speed = speed
        entity[n].img = img
        entity[n].canBeOnMap = canBeOnMap
        -- Constants at creation
        entity[n].posX = 0
        entity[n].posY = 0
        entity[n].destinationX = 0 
        entity[n].destinationY = 0 
        entity[n].distanceToDestination = 0 
        entity[n].speedX = 0
        entity[n].speedY = 0
        entity[n].onMap = false
        entity[n].isMoving = false
        -- For object generation
        entity[n].isEntity = true
        entity[n].alwaysDrawn = true
        entity[n].imgPassive = img
        entity[n].handlerL = handlerEntityLeftClick
        entity[n].handlerR = handlerEntityRightClick


        if canBeOnMap == true then
            entity[n].posX = coordPosConverter("CoordToPos",coordX)
            entity[n].posY = coordPosConverter("CoordToPos",coordY)
            createObject(entity[n])
        end
    end
    
    createEntity(
        "test_entity",
        0, 0,
        1,
        img.map.entity[1],
        true
    )
    createEntity(
        "test_entity",
        -1, -1,
        1,
        img.map.entity[1],
        true
    )
    createEntity(
        "test_entity",
        1, 1,
        1,
        img.map.entity[1],
        true
    )
-- Screen 1 (Title Screen)
    menu[1].id = 1
        menu[1].screen = 1
        menu[1].hasScroll = false
        menu[1].scrollTotalN = 3
        menu[1].scrollVisibleN = 5
        menu[1].fontSize = 30
        menu[1].font = love.graphics.newFont("fonts/kenvector_future_thin.ttf", menu[1].fontSize) 
        menu[1].posYOffset = menu[1].fontSize * 2
        menu[1].width = 400
        menu[1].height = 80
        menu[1].posX = (love.graphics.getWidth() - menu[1].width) / 2
        menu[1].posY = 200
        menu[1].hasImg = true
        menu[1].imgPassive = img.button.passive[1]
        menu[1].imgActive = img.button.active[1]
        menu[1].hasButtons = true
        menu[1].hasText = false
        menu[1].textColorNormal = {1,1,1}
        menu[1].textColorHighlight = {0.8, 0.6, 0.4}
        menu[1].alwaysDrawn = true
        menu[1].object = {
            [1] = {text = "New Game", handlerL = handlerScreenMap},
            [2] = {text = "Settings", handlerL = handlerEmpty},
            [3] = {text = "Exit", handlerL = handlerExitGame}
        }

    for i = 1, #menu[1].object do
        menu.object.n = menu.object.n + 1
        menu[1].object[i].id = menu.object.n
        menu[1].object[i].screen = menu[1].screen
        if menu[1].scrollTotalN - menu[1].scrollVisibleN > 0 then
            menu[1].object[i].hasScroll = true
        else
            menu[1].object[i].hasScroll = false
        end
        menu[1].object[i].scrollTotalN = menu[1].scrollTotalN
        menu[1].object[i].scrollVisibleN = menu[1].scrollVisibleN
        menu[1].object[i].scrollDist = menu[1].posYOffset
        menu[1].object[i].scissorPosX = menu[1].posX
        menu[1].object[i].scissorPosY = menu[1].posY
        menu[1].object[i].scissorWidth = menu[1].width
        menu[1].object[i].scissorHeight = menu[1].height
        menu[1].object[i].handlerR = handlerEmpty
        menu[1].object[i].alwaysDrawn = menu[1].alwaysDrawn
        menu[1].object[i].posX = menu[1].posX + 50
        menu[1].object[i].posY = menu[1].posY + (i-1) * menu[1].posYOffset
        menu[1].object[i].hasImg = menu[1].hasImg
        menu[1].object[i].imgPassive = menu[1].imgPassive
        menu[1].object[i].imgActive = menu[1].imgActive
        menu[1].object[i].isButton = menu[1].hasButtons
        menu[1].object[i].hasText = menu[1].hasText
        menu[1].object[i].textColorNormal = menu[1].textColorNormal
        menu[1].object[i].textColorHighlight = menu[1].textColorHighlight
        menu[1].object[i].fontSize = menu[1].fontSize
        menu[1].object[i].font = menu[1].font

        createObject(menu[1].object[i])
    end

    menu[3].id = 3
        menu[3].screen = 1
        menu[3].scrollTotalN = 21
        menu[3].scrollVisibleN = 8
        menu[3].hasScroll = true
        menu[3].fontSize = 24
        menu[3].font = love.graphics.newFont("fonts/kenvector_future_thin.ttf", menu[3].fontSize) 
        menu[3].posYOffset = menu[3].fontSize * 2
        menu[3].width = 300
        menu[3].height = menu[3].posYOffset * 8 - 10
        menu[3].posX = 1000
        menu[3].posY = 200
        menu[3].hasImg = false
        menu[3].imgPassive = img.button.passive[1]
        menu[3].imgActive = img.button.active[1]
        menu[3].hasButtons = false
        menu[3].isOnlyText = true
        menu[3].hasText = true
        menu[3].textPosX = menu[3].posX + 20
        menu[3].textColorNormal = {1,1,1}
        menu[3].textColorHighlight = {0.8, 0.6, 0.4}
        menu[3].alwaysDrawn = true
        menu[3].object = {
        }
    

    for i = 1, menu[3].scrollTotalN do
        menu.object.n = menu.object.n + 1
        menu[3].object[i] = {}
        menu[3].object[i].text = "option"..i
        menu[3].object[i].id = menu.object.n
        menu[3].object[i].screen = menu[3].screen
        if menu[3].scrollTotalN - menu[3].scrollVisibleN > 0 then
            menu[3].object[i].hasScroll = true
        else
            menu[3].object[i].hasScroll = false
        end
        menu[3].object[i].scrollTotalN = menu[3].scrollTotalN
        menu[3].object[i].scrollVisibleN = menu[3].scrollVisibleN
        menu[3].object[i].scrollDist = menu[3].posYOffset
        menu[3].object[i].scissorPosX = menu[3].posX
        menu[3].object[i].scissorPosY = menu[3].posY
        menu[3].object[i].scissorWidth = menu[3].width
        menu[3].object[i].scissorHeight = menu[3].height
        menu[3].object[i].handlerL = handlerEmpty
        menu[3].object[i].handlerR = handlerEmpty
        menu[3].object[i].alwaysDrawn = menu[3].alwaysDrawn
        menu[3].object[i].posX = menu[3].textPosX
        menu[3].object[i].posY = menu[3].posY + (i-1) * menu[3].posYOffset + 5
        menu[3].object[i].hasImg = menu[3].hasImg
        menu[3].object[i].imgPassive = menu[3].imgPassive
        menu[3].object[i].imgActive = menu[3].imgActive
        menu[3].object[i].isButton = menu[3].hasButtons
        menu[3].object[i].isOnlyText = menu[3].isOnlyText
        menu[3].object[i].hasText = menu[3].hasText
        menu[3].object[i].textColorNormal = menu[3].textColorNormal
        menu[3].object[i].textColorHighlight = menu[3].textColorHighlight
        menu[3].object[i].fontSize = menu[3].fontSize
        menu[3].object[i].font = menu[3].font
        createObject(menu[3].object[i])
    end
    menu[4].id = 4
        menu[4].screen = 1
        menu[4].scrollTotalN = 12
        menu[4].scrollVisibleN = 8
        menu[4].hasScroll = true
        menu[4].fontSize = 24
        menu[4].font = love.graphics.newFont("fonts/kenvector_future_thin.ttf", menu[4].fontSize) 
        menu[4].posYOffset = menu[4].fontSize * 2
        menu[4].width = 200
        menu[4].height = menu[4].posYOffset * 8 - 10
        menu[4].posX = 1300
        menu[4].posY = 200
        menu[4].hasImg = true
        menu[4].imgPassive = img.ui.checkboxPassive[1]
        menu[4].imgActive = img.ui.checkboxActive[1]
        menu[4].isCheckBox = true
        menu[4].hasText = false
        menu[4].textPosX = menu[4].posX + 10
        menu[4].textColorNormal = {1,1,1}
        menu[4].textColorHighlight = {0.8, 0.6, 0.4}
        menu[4].alwaysDrawn = true
        menu[4].object = {
        }
    

    for i = 1, menu[4].scrollTotalN do
        menu.object.n = menu.object.n + 1
        menu[4].object[i] = {}
        menu[4].object[i].text = "checkBox"..i
        menu[4].object[i].id = menu.object.n
        menu[4].object[i].screen = menu[4].screen
        if menu[4].scrollTotalN - menu[4].scrollVisibleN > 0 then
            menu[4].object[i].hasScroll = true
        else
            menu[4].object[i].hasScroll = false
        end
        menu[4].object[i].scrollTotalN = menu[4].scrollTotalN
        menu[4].object[i].scrollVisibleN = menu[4].scrollVisibleN
        menu[4].object[i].scrollDist = menu[4].posYOffset
        menu[4].object[i].scissorPosX = menu[4].posX
        menu[4].object[i].scissorPosY = menu[4].posY
        menu[4].object[i].scissorWidth = menu[4].width
        menu[4].object[i].scissorHeight = menu[4].height
        menu[4].object[i].handlerL = handlerEmpty
        menu[4].object[i].handlerR = handlerEmpty
        menu[4].object[i].alwaysDrawn = menu[4].alwaysDrawn
        menu[4].object[i].posX = menu[4].textPosX
        menu[4].object[i].posY = menu[4].posY + (i-1) * menu[4].posYOffset + 5
        menu[4].object[i].hasImg = menu[4].hasImg
        menu[4].object[i].imgPassive = menu[4].imgPassive
        menu[4].object[i].imgActive = menu[4].imgActive
        menu[4].object[i].isButton = menu[4].hasButtons
        menu[4].object[i].isCheckBox = menu[4].isCheckBox
        menu[4].object[i].hasText = menu[4].hasText
        menu[4].object[i].textColorNormal = menu[4].textColorNormal
        menu[4].object[i].textColorHighlight = menu[4].textColorHighlight
        menu[4].object[i].fontSize = menu[4].fontSize
        menu[4].object[i].font = menu[4].font
        createObject(menu[4].object[i])
    end
-- Screen 2 (Map)
    menu[2].id = 2
        menu[2].screen = 2
        menu[2].hasScroll = true
        menu[2].isOnlyText = true
        menu[2].hasBackground = true
        menu[2].scrollTotalN = 12
        menu[2].scrollVisibleN = 8
        menu[2].fontSize = 24
        menu[2].font = love.graphics.newFont("fonts/kenvector_future_thin.ttf", menu[2].fontSize) 
        menu[2].posYOffset = menu[2].fontSize * 2
        menu[2].width = 400
        menu[2].height = menu[2].posYOffset * 8 - 10
        menu[2].posX = 0
        menu[2].posY = 0
        menu[2].hasImg = false
        menu[2].imgPassive = img.button.passive[1]
        menu[2].imgActive = img.button.active[1]
        menu[2].textPosX = menu[2].posX + 50
        menu[2].textColorNormal = {1,1,1}
        menu[2].textColorHighlight = {0.8, 0.6, 0.4}
        menu[2].alwaysDrawn = true
        menu[2].object = {}

    for i = 1, menu[2].scrollTotalN do
        menu.object.n = menu.object.n + 1
        menu[2].object[i] = {}
        menu[2].object[i].text = "unit"..i
        menu[2].object[i].id = menu.object.n
        menu[2].object[i].screen = menu[2].screen
        if menu[2].scrollTotalN - menu[2].scrollVisibleN > 0 then
            menu[2].object[i].hasScroll = true
        else
            menu[2].object[i].hasScroll = false
        end
        menu[2].object[i].hasBackground = menu[2].hasBackground
        menu[2].object[i].scrollTotalN = menu[2].scrollTotalN
        menu[2].object[i].scrollVisibleN = menu[2].scrollVisibleN
        menu[2].object[i].scrollDist = menu[2].posYOffset
        menu[2].object[i].scissorPosX = menu[2].posX
        menu[2].object[i].scissorPosY = menu[2].posY
        menu[2].object[i].scissorWidth = menu[2].width
        menu[2].object[i].scissorHeight = menu[2].height
        menu[2].object[i].handlerL = handlerEmpty
        menu[2].object[i].handlerR = handlerEmpty
        menu[2].object[i].alwaysDrawn = menu[2].alwaysDrawn
        menu[2].object[i].posX = menu[2].textPosX 
        menu[2].object[i].posY = menu[2].posY + (i-1) * menu[2].posYOffset + 5
        menu[2].object[i].hasImg = menu[2].hasImg
        menu[2].object[i].imgPassive = menu[2].imgPassive
        menu[2].object[i].imgActive = menu[2].imgActive
        menu[2].object[i].isButton = menu[2].hasButtons
        menu[2].object[i].isOnlyText = menu[2].isOnlyText
        menu[2].object[i].hasText = menu[2].hasText
        menu[2].object[i].textColorNormal = menu[2].textColorNormal
        menu[2].object[i].textColorHighlight = menu[2].textColorHighlight
        menu[2].object[i].fontSize = menu[2].fontSize
        menu[2].object[i].font = menu[2].font
        createObject(menu[2].object[i])
    end
-- Game Start
    function startNewGame()
        love.graphics.setCanvas (map[1].canvas)
            for i = 0, map.width do
                for j = 0, map.height do
                    createTile(1,i,j)
                end
            end
        love.graphics.setCanvas()
        handlerScreenTitle()
    end
    startNewGame()
--
function love.load()
    require("strict")  --(if variables are somehow not declared beforehand, an error will appear. This is to avoid having unnecessary variables)
end
function resetValues()
    mouse.clickL = false
    mouse.wheel.scroll = 0
end
-- Debug
    debug = {}
    debug.fontSize = 20
    debug.font = love.graphics.newFont(debug.fontSize)
    debug.Msg = "-"
    function updateDebug()
        debug.list = {
            {active = 0 , name = "button[1].buttonPosX", data = button[1].buttonPosX},
            {active = 0 , name = "camera[gm.screen.i].y", data = camera[gm.screen.i].y},
            {active = 0 , name = "entity[2].coordX", data = entity[2].coordX},
            {active = 0 , name = "entity[2].posX", data = entity[2].posX},
            {active = 1 , name = "#button.activeId", data = #button.activeId},
        }
    end

    function drawDebug()
        local n = 0
        love.graphics.setFont(debug.font)
        love.graphics.setColor(1,1,1)
        for i = 1, #debug.list do
            if debug.list[i].active == 1 then
                love.graphics.print(debug.list[i].name..": "..debug.list[i].data,-camera[gm.screen.i].x,-camera[gm.screen.i].y + n*22)
                n = n + 1
            end
        end
    end
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function love.update()
    updateTiles()
    updateButtons()
    updateObjects()
    updateDebug()
end


------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function love.draw()

    if gm.screen.i == 1 then
        love.graphics.translate(camera[1].x, camera[1].y)
    end
    if gm.screen.i == 2 then
        love.graphics.translate(camera[2].x, camera[2].y)
        love.graphics.draw(map[1].canvas, map[1].canvasPosX, map[1].canvasPosY)
    end
    drawButton()
    --drawObject()
    drawDebug()
    resetValues()
end

------------------------------------------------------------------------------------------------------------------------------------------------------------------------